[洛谷1822]魔法指纹 题解
题目地址:ė …
May all the beauty be blessed.
给一个CMY?序列,要求找到是否存在两种或以上填空方法使得这个字符串满足相邻两个字符不同的要求。
其实最好写的做法应该是DFS试图寻找两个方案,找到两个就直接exit。不过我这场的时候头铁写了各种if。
既然写了if的方法就来说说思路吧。我们观察连续?的各种情况:
C?C
,显然这里有两种填法,出现这种情况就可以Yes了C?M
,只能填一个,跳过C??C
,有至少两种填法C??M
,有至少两种填法C???C
,有至少两种填法C???M
,填法就比较多了,至少有两种?
更多的情况显然方案数更多那么可行的情况是:
?
不少于2个?
且左右两边字符相同接着还有绝对不合法的情况:
?
且相同判完就能AC了。头还是不够硬,fst了。
// Code by KSkun
#include <cstdio>
int n;
char str[105];
int main() {
scanf("%d%s", &n, str + 1);
str[0] = '?';
str[n + 1] = '?';
bool success = false;
for(int i = 1; i <= n + 1; i++) {
if(str[i] == '?') {
if(str[i - 1] == '?' || str[i + 1] == '?' ||
(str[i - 1] != '?' && str[i + 1] != '?' && str[i - 1] == str[i + 1])) {
success = true;
}
} else {
if(str[i - 1] != '?' && str[i] == str[i - 1]) {
success = false;
break;
}
}
}
if(success) printf("Yes"); else printf("No");
return 0;
}
a一类,b一类,c可以转变为a或b类,想让相同数量的a类b类混一起,求最大数量。
考虑贪心。
如果a+c < b或者b+c < a答案就是2倍的a、b中较小值加上c。
否则我们把一部分c转换成ab中较少的那一类使得a=b,再平分剩下的c。
// Code by KSkun, 2018/3
#include <cstdio>
#include <algorithm>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
int l, r, a;
int main() {
l = readint();
r = readint();
a = readint();
if(a >= std::abs(r - l)) {
a -= std::abs(r - l);
printf("%d", (std::max(l, r) + a / 2) * 2);
} else {
printf("%d", (std::min(l, r) + a) * 2);
}
return 0;
}
琪露诺(就是那个声称幻想乡没有巴士的小妖精)被幻想乡公交公司聘用为调度员,她现在正在管理雾之湖车站的进出站。具体而言,她现在拥有一份这个车站的时刻表,有若干班车按照时刻表的计划进站。每一班车进站需要 1 分钟时间。
不妙的是,有一班紧急班车需要临时进站,她现在想要将它的进站时间安排在某两班车之间的空隙中。这班车的进站也只需要 1 分钟,但是为了安全保证,它进站之前之后 s 分钟内不得有其他班车正在进站。
由于班车很紧急,琪露诺需要找到最早可以插入这班车的时间。不过由于她又去冻青蛙+1s了,所以你要来帮她解决这个问题。
就是直接模拟一遍嘛。
注意特判一下是否能放在开头、结尾就行了。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cctype>
#include <algorithm>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(!isdigit(c)) {
if(c == '-') neg = -1;
c = fgc();
}
while(isdigit(c)) {
res = (res << 1) + (res << 3) + c - '0';
c = fgc();
}
return res * neg;
}
int n, s, h[105], m[105];
int main() {
n = readint(); s = readint();
for(int i = 1; i <= n; i++) {
h[i] = readint(); m[i] = readint();
}
if(h[1] * 60 + m[1] >= s + 1) {
printf("0 0");
return 0;
}
for(int i = 2; i <= n; i++) {
int del = (h[i] - h[i - 1] - 1) * 60 + m[i] + 60 - m[i - 1] - 1;
if(del >= s * 2 + 1) {
m[i - 1] += s + 1;
h[i - 1] += m[i - 1] / 60;
m[i - 1] %= 60;
printf("%d %d", h[i - 1], m[i - 1]);
return 0;
}
}
m[n] += s + 1;
h[n] += m[n] / 60;
m[n] %= 60;
printf("%d %d", h[n], m[n]);
return 0;
}
有一个只由0和1构成的字符串。我们规定,题目中所有合法的01串都满足以下性质:
你可以对一个01串进行下列操作:
我们规定记号 val(s) 是二进制表示为01串 s 的那个数字。而称01串 a 小于01串 b 当且仅当 val(a) < val(b) 。
现在,你要找到一个最小的合法01串且这个01串可以由给定的01串 s 经过上述操作变化而来。
实质你可以把一堆1全部转到前面然后消成1个1,因此答案就是1后面跟原来字符串里有的0。
注意如果整个字符串没有1,只需要输出0。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cctype>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(!isdigit(c)) {
if(c == '-') neg = -1;
c = fgc();
}
while(isdigit(c)) {
res = (res << 1) + (res << 3) + c - '0';
c = fgc();
}
return res * neg;
}
inline bool is01(char c) {
return c == '0' || c == '1';
}
inline int read01() {
char c;
while(!is01(c = fgc()));
return c - '0';
}
int n, c0, c1;
int main() {
n = readint();
for(int i = 1; i <= n; i++) {
if(read01() == 0) c0++; else c1++;
}
if(!c1) {
puts("0");
return 0;
}
putchar('1');
while(c0--) {
putchar('0');
}
return 0;
}
题目地址:洛谷:【P1993】小K的农场 – 洛谷
小K在MC里面建立很多很多的农场,总共n个,以至于他自己都忘记了每个农场中种植作物的具体数量了,他只记得一些含糊的信息(共m个),以下列三种形式描述:
但是,由于小K的记忆有些偏差,所以他想要知道存不存在一种情况,使得农场的种植作物数量与他记忆中的所有信息吻合。
输入格式:
第一行包括两个整数 n 和 m,分别表示农场数目和小 K 记忆中的信息数目。
接下来 m 行:
如果每行的第一个数是 1,接下来有 3 个整数 a,b,c,表示农场 a 比农场 b 至少多种植了 c 个单位的作物。
如果每行的第一个数是 2,接下来有 3 个整数 a,b,c,表示农场 a 比农场 b 至多多种植了 c 个单位的作物。
如果每行的第一个数是 3,家下来有 2 个整数 a,b,表示农场 a 终止的数量和 b 一样多。
输出格式:
如果存在某种情况与小 K 的记忆吻合,输出“Yes”,否则输出“No”。
输入样例#1:
3 3 3 1 2 1 1 3 1 2 2 3 2
输出样例#1:
Yes
对于 100% 的数据保证:1 ≤ n,m,a,b,c ≤ 10000。
一个差分约束的裸题。
我们考虑一组条件:
\begin{gathered} f(a) - f(b) \leq p \\ f(b) - f(c) \leq q \end{gathered}
显然有f(a) - f(c) \leq p + q。这个可以用图上的边表示出来,我们从a向b连边权p的边,b向c连边权q的边,则产生了a到c的路径,路径权值和为p+q,就能表示上面的不等式合并。
我们考虑如果a到c有多条路径,对应的是一组形如f(a) - f(c) \leq k_i的条件,我们肯定只取f(a) - f(c) \leq \min\{k_i\}即可,这在图上就是最短路。
对于本题,条件1是f(a) - f(b) \geq c转化为f(b) - f(a) \leq -c建边,条件2直接建边,条件3为f(a) - f(b) = 0,用f(a) - f(b) \leq 0和f(b) - f(a) \leq 0来表示。
差分约束系统存在可行解的充要条件是图中不存在负环,即满足对于任意点,不存在f(a) - f(a) < 0的情况。我们用DFS式SPFA来判断是否存在负环。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cctype>
#include <vector>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(!isdigit(c)) {
if(c == '-') neg = -1;
c = fgc();
}
while(isdigit(c)) {
res = (res << 1) + (res << 3) + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 10005;
struct Edge {
int to, w;
};
std::vector<Edge> gra[MAXN];
int n, m;
int dis[MAXN];
bool vis[MAXN], has;
inline void dfs(int u) {
vis[u] = true;
for(Edge e : gra[u]) {
int v = e.to;
if(dis[v] > dis[u] + e.w) {
if(vis[v]) {
has = true;
return;
}
dis[v] = dis[u] + e.w;
dfs(v);
}
if(has) return;
}
vis[u] = false;
}
int op, a, b, c;
int main() {
n = readint(); m = readint();
while(m--) {
op = readint(); a = readint(); b = readint();
if(op == 1) {
c = readint();
gra[b].push_back(Edge {a, -c});
} else if(op == 2) {
c = readint();
gra[a].push_back(Edge {b, c});
} else {
gra[a].push_back(Edge {b, 0});
gra[b].push_back(Edge {a, 0});
}
}
for(int i = 1; i <= n; i++) {
dfs(i);
if(has) break;
}
if(has) puts("No"); else puts("Yes");
return 0;
}
题目地址:洛谷:【P2444】[POI2000]病毒 – 洛谷、BZOJ:Problem 2938. — [Poi2000]病毒
二进制病毒审查委员会最近发现了如下的规律:某些确定的二进制串是病毒的代码。如果某段代码中不存在任何一段病毒代码,那么我们就称这段代码是安全的。现在委员会已经找出了所有的病毒代码段,试问,是否存在一个无限长的安全的二进制代码。
示例:
例如如果{011, 11, 00000}为病毒代码段,那么一个可能的无限长安全代码就是010101…。如果{01, 11, 000000}为病毒代码段,那么就不存在一个无限长的安全代码。
任务:
请写一个程序:
1.在文本文件WIR.IN中读入病毒代码;
2.判断是否存在一个无限长的安全代码;
3.将结果输出到文件WIR.OUT中。
输入格式:
在文本文件WIR.IN的第一行包括一个整数n(n≤2000),表示病毒代码段的数目。以下的n行每一行都包括一个非空的01字符串——就是一个病毒代码段。所有病毒代码段的总长度不超过30000。
输出格式:
在文本文件WIR.OUT的第一行输出一个单词:
TAK——假如存在这样的代码;
NIE——如果不存在。
输入样例#1:
3 01 11 00000
输出样例#1:
NIE
这个题要找的是一个无限的安全代码,我们考虑用AC自动机的理论来做。
如果把AC自动机的fail和边全部看成有向边,这个图就叫做trie图,图上的某一条路径可以代表我们匹配的过程。安全代码的匹配过程中肯定是不会有不安全的代码段结尾的节点的,又因为无限长的安全代码匹配过程肯定是无限的,如果在trie图上找到一个环,使得环上不出现不安全代码的结尾,那么说明存在这样一个无限循环的安全代码。
因此本题的思路就是在trie图上DFS找环。
// Code by KSkun, 2018/3
#include <cstdio>
#include <queue>
const int MAXN = 30005;
int ch[MAXN][2], fail[MAXN], cnt;
bool val[MAXN];
std::queue<int> que;
inline void insert(char *str) {
int p = 0;
for(int i = 0; str[i]; i++) {
if(!ch[p][str[i] - '0']) ch[p][str[i] - '0'] = ++cnt;
p = ch[p][str[i] - '0'];
}
val[p] = true;
}
inline void calfail() {
for(int i = 0; i <= 1; i++) {
if(ch[0][i]) {
fail[ch[0][i]] = 0;
que.push(ch[0][i]);
}
}
while(!que.empty()) {
int u = que.front(); que.pop();
for(int i = 0; i <= 1; i++) {
if(ch[u][i]) {
fail[ch[u][i]] = ch[fail[u]][i];
val[ch[u][i]] |= val[fail[ch[u][i]]];
que.push(ch[u][i]);
} else {
ch[u][i] = ch[fail[u]][i];
}
}
}
}
bool vis[MAXN], visd[MAXN], success = false;
inline void dfs(int p) {
vis[p] = true;
for(int i = 0; i <= 1; i++) {
if(vis[ch[p][i]]) {
success = true;
return;
}
if(!val[ch[p][i]] && !visd[ch[p][i]]) {
visd[ch[p][i]] = true;
dfs(ch[p][i]);
if(success) return;
}
}
vis[p] = false;
}
int n;
char str[MAXN];
int main() {
scanf("%d", &n);
for(int i = 0; i < n; i++) {
scanf("%s", str);
insert(str);
}
calfail();
dfs(0);
puts(success ? "TAK" : "NIE");
return 0;
}